/* PS/2 keyboard reader Forrest Heller */
module ps2(output reg char_recieved,
			 output reg parity_error, 
			 output reg [7:0] current_char,
			 input wire ps2_clock,
			 input wire ps2_data,
			 input wire clk
			 );
	reg [4:0] state = 0;
	reg parity;
	reg last_ps2_clk;
	reg last_last_ps2_clk;
	reg last_ps2_data;
	
	
	wire is_falling_clock;
	always @(posedge clk)
	begin
		last_ps2_data <= ps2_data;
		last_ps2_clk <= ps2_clock;
	
		last_last_ps2_clk <= last_ps2_clk;
		
		if (last_last_ps2_clk == 1 && last_ps2_clk == 0 && state >= 1 && state <= 8)
			current_char[state - 1] <= last_ps2_data;
		else
			current_char <= current_char;
		if (last_last_ps2_clk == 1 && last_ps2_clk == 0)
			if (state == 10) 
				state <= 0;
			else
				state <= state + 5'd1;
		else
			state <= state;			
		if (last_last_ps2_clk == 1 && last_ps2_clk == 0 && state == 10 && char_recieved == 0)
			char_recieved <= 1;
		else
			char_recieved <= 0;
		if (last_last_ps2_clk == 1 && last_ps2_clk == 0 && state >= 1 && state <= 8 && last_ps2_data)
			parity <= !parity;
		else if (state == 0) 
			parity <= 0;
		else
			parity <= parity;
		if (last_last_ps2_clk == 1 && last_ps2_clk == 0)
			if (state == 9) 
				if (parity == last_ps2_data)
					parity_error <= 1;
				else
					parity_error <= 0;
			else
				parity_error <= parity_error;
		else
			parity_error <= parity_error;
	end
endmodule